setwd("/Users/sebastian/git/projects/bigquery/gh/")
#setwd("E:/Git/projects/bigquery/gh/")

gh_repos <- read.csv("gh_repos.csv", header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)

summary(gh_repos$watcher_count)
# Min.  1st Qu.   Median     Mean  3rd Qu.     Max. 
# 0.00     0.00     0.00     2.33     0.00 80450.00 

d <- density(gh_repos$watcher_count)
plot(d)

length(which(gh_repos$watcher_count==0))/nrow(gh_repos)*100
# 86.06195

length(which(gh_repos$watcher_count==1))/nrow(gh_repos)*100
# 7.183946

length(which(gh_repos$watcher_count==2))/nrow(gh_repos)*100
# 2.096546

table(gh_repos$watcher_count[gh_repos$watcher_count<=10])
# 0        1        2        3        4        5        6        7        8        9       10 
# 17416846  1453856   424290   205367   122625    82439    60151    45751    36589    29789    24930  

quantile(gh_repos$watcher_count, 0.75)
# 75% 
# 0

quantile(gh_repos$watcher_count, 0.99)
# 99% 
# 21

gh_repos_sample <- gh_repos[gh_repos$watcher_count>=21,]
nrow(gh_repos_sample)/nrow(gh_repos)
# 0.01022228

summary(gh_repos_sample$watcher_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 21.0    30.0    52.0   193.2   122.0 80450.0 

write.table(gh_repos_sample, file="gh_repos_sample.csv", sep=";", col.names=TRUE, row.names=FALSE, na="", quote=TRUE, qmethod="double", fileEncoding="UTF-8")
